<svelte:options immutable={true} />

<script>
	import Chart from 'svelte-frappe-charts';
	import { only, pluck } from '$lib/array';
	import { dateFromParts } from '$lib/date';
	import { dashboardStation } from '$lib/preferences';
	import { periodConfig, periodKeys, periodSelector, precipitations } from '$lib/Widgets/stores';
	import { writable } from 'svelte/store';

	const aggregateSelector = writable('sum');
	let url;

	const fetchData = (period, aggregate) => {
		fetch(`${url}?period=${period}&aggregate=${aggregate}`)
			.then(async (req) => await req.json())
			.then((data) => {
				const chartData = {
					labels: only(data, $periodKeys).map((label) => dateFromParts(label, $periodConfig)),
					datasets: [{ name: 'Precipitations', values: pluck(data, 'rr') }]
				};
				if (aggregate === 'sum') {
					if (period === 'monthly') {
						chartData.datasets.push({ name: 'Normales', values: pluck(data, 'normale') });
					} else if (period === 'yearly') {
						chartData.yMarkers = [
							{ label: 'Normale', value: pluck(data, 'normale')[0], options: { labelPos: 'left' } }
						];
					}
				}

				precipitations.set({
					period,
					aggregate,
					data: chartData
				});
			});
	};

	$: {
		url = `https://api.infoclimat.localhost/api/station/${$dashboardStation.id}/precipitations`;
		fetchData($periodSelector, $aggregateSelector);
	}
</script>

<div class="card col-span-4 xl:col-span-2 min-h-[4rem]">
	{#if $periodSelector !== 'daily'}
		<div class="relative">
			<div class="flex gap-x-4 items-center justify-end w-full z-10">
				<label>
					<input type="radio" bind:group={$aggregateSelector} value={'sum'} />
					Sommes
				</label>
				<label>
					<input type="radio" bind:group={$aggregateSelector} value={'avg'} />
					Moyennes
				</label>
			</div>
		</div>
	{/if}
	{#key $precipitations.data}
		<Chart
			data={$precipitations.data}
			type="line"
			title="Évolution des cumuls de pluie tombés à la station en mm"
			axisOptions={{ xIsSeries: 1, xAxisMode: 'tick' }}
			lineOptions={{
				hideDots: true,
				line: true
			}}
			tooltipOptions={{
				formatTooltipY: (d) => parseFloat(d).toFixed(2) + ' mm'
			}}
		/>
	{/key}
</div>

<style lang="postcss">
	.card {
		@apply bg-white shadow p-3 rounded-md transition-shadow duration-200 ease-out;
	}
</style>
